SystemOrganization addCategory: #'RobotSoccer-Model'!
SystemOrganization addCategory: #'RobotSoccer-Tests'!
SystemOrganization addCategory: #'RobotSoccer-Viewer-Plugins'!
SystemOrganization addCategory: #'RobotSoccer-Viewer'!
SystemOrganization addCategory: #'RobotSoccer-Strategy-Performance'!
SystemOrganization addCategory: #'RobotSoccer-Strategy-Example'!
SystemOrganization addCategory: #'RobotSoccer-Servers'!
SystemOrganization addCategory: #'RobotSoccer-Servers-Simulated'!
SystemOrganization addCategory: #'RobotSoccer-Servers-Real'!

EllipseMorph subclass: #RSBallMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!RSBallMorph methodsFor: 'initialize' stamp: 'Richo 10/9/2009 16:25'!
initialize
super initialize.
self extent:  10.675@10.675; color: Color orange! !

Object subclass: #RSAngle
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

!RSAngle class methodsFor: 'instance creation' stamp: 'Richo 6/21/2008 19:57'!
degrees: aNumber 
	^ self basicNew inDegrees: aNumber! !

!RSAngle class methodsFor: 'instance creation' stamp: 'Richo 6/23/2008 11:49'!
new
self shouldNotImplement! !

!RSAngle class methodsFor: 'instance creation' stamp: 'Richo 6/21/2008 19:57'!
radians: aNumber
^self basicNew inRadians: aNumber! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/22/2008 22:15'!
+ anAngle 
	"Suma manteniendo entre -180 y 180"
	| nuevo |
	nuevo := self degrees + anAngle degrees.
	nuevo > 180
		ifTrue: [nuevo := self degrees - (360 - anAngle degrees)].
	nuevo < -180
		ifTrue: [^ self - anAngle negated].
	^ RSAngle degrees: nuevo! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/22/2008 22:15'!
- anAngle 
	"Resta manteniendo el valor entre -180 y 180"
	| nuevo |
	nuevo := self degrees - anAngle degrees.
	nuevo < -180
		ifTrue: [nuevo := self degrees + (360 - anAngle degrees)].
	nuevo > 180
		ifTrue: [^ self + anAngle negated].
	^ RSAngle degrees: nuevo! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/21/2008 20:01'!
< anAngle 
	^ self degrees < anAngle degrees! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/21/2008 20:01'!
= anAngle 
	^ self radians closeTo: anAngle radians! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/21/2008 20:01'!
> anAngle 
	^ self degrees > anAngle degrees! !

!RSAngle methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:59'!
degrees
^value radiansToDegrees ! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/21/2008 20:01'!
diff: anAngle 
	| dif |
	dif := self - anAngle.
	^ dif degrees abs! !

!RSAngle methodsFor: 'initialization' stamp: 'Richo 6/21/2008 19:59'!
inDegrees: aNumber 
	value := aNumber degreesToRadians ! !

!RSAngle methodsFor: 'initialization' stamp: 'Richo 6/21/2008 19:58'!
inRadians: aNumber
value := aNumber! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/22/2008 22:15'!
negated
	^ RSAngle degrees: self degrees negated! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/22/2008 22:15'!
opposite
	^ self
		+ (RSAngle degrees: 180)! !

!RSAngle methodsFor: 'copying' stamp: 'Richo 10/6/2009 12:15'!
postCopy
super postCopy.
value := value copy.! !

!RSAngle methodsFor: 'printing' stamp: 'Richo 6/23/2008 11:47'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '(' , self degrees asString , ' degrees)'! !

!RSAngle methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:59'!
radians
	^ value! !

Object subclass: #RSBall
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

!RSBall methodsFor: 'initialization' stamp: 'Richo 6/21/2008 19:47'!
initialize
position := 0@0! !

!RSBall methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:46'!
position
^position! !

!RSBall methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:51'!
position: aPoint 
position := aPoint! !

!RSBall methodsFor: 'copying' stamp: 'Richo 10/6/2009 12:15'!
postCopy
super postCopy.
position := position copy.! !

Object subclass: #RSEnvironment
	instanceVariableNames: 'home opponent currentBall lastBall fieldBounds goalBounds gameState whosBall isYellowTeam lastEnvironments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

RSEnvironment class
	instanceVariableNames: 'example'!

RSEnvironment class
	instanceVariableNames: 'example'!

!RSEnvironment class methodsFor: 'test' stamp: 'Richo 10/9/2009 16:03'!
example
^example! !

!RSEnvironment class methodsFor: 'test' stamp: 'Richo 10/9/2009 16:03'!
example: anRSEnvironment
example := anRSEnvironment ! !

!RSEnvironment class methodsFor: 'instance creation' stamp: 'Richo 10/13/2009 12:40'!
newForTeam: teamClass
	^( self basicNew initializeForTeam: teamClass)
		 initialize! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
currentBall
	"Answer the value of currentBall"

	^ currentBall! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
currentBall: anObject
	"Set the value of currentBall"

	currentBall := anObject! !

!RSEnvironment methodsFor: 'inverting field' stamp: 'Richo 3/31/2009 16:38'!
decideTeam
	| rightSide leftSide |
	isYellowTeam
		ifNotNil: [^ self].
	rightSide := 0.
	leftSide := 0.
	home
		do: [:each | each position x > fieldBounds center x
				ifTrue: [rightSide := rightSide + 1]
				ifFalse: [leftSide := leftSide + 1]].
	opponent
		do: [:each | each position x > fieldBounds center x
				ifTrue: [rightSide := rightSide - 1]
				ifFalse: [leftSide := leftSide - 1]].
	isYellowTeam := leftSide > rightSide.
! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
fieldBounds
	"Answer the value of fieldBounds"

	^ fieldBounds! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
fieldBounds: anObject
	"Set the value of fieldBounds"

	fieldBounds := anObject! !

!RSEnvironment methodsFor: 'accessing mementos' stamp: 'Richo 10/18/2009 17:36'!
firstEnvironment

 ^lastEnvironments isEmpty ifTrue: [self] ifFalse: [lastEnvironments first]! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:54'!
gameState
	"Answer the value of gameState"

	^ gameState! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:54'!
gameState: anObject
	"Set the value of gameState"

	gameState := anObject! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
goalBounds
	"Answer the value of goalBounds"

	^ goalBounds! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
goalBounds: anObject
	"Set the value of goalBounds"

	goalBounds := anObject! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
home
	"Answer the value of home"

	^ home! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
home: anObject
	"Set the value of home"

	home := anObject! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 20:22'!
homeAt: aSmallInteger
^home at: aSmallInteger ! !

!RSEnvironment methodsFor: 'initialize' stamp: 'Richo 10/13/2009 11:50'!
initialize
super initialize.
lastEnvironments := OrderedCollection new."
fieldBounds := goalBounds := 0@0 corner: 1@1.
gameState := 0.
whosBall := 0.
isYellowTeam := false."! !

!RSEnvironment methodsFor: 'initialize' stamp: 'Richo 10/13/2009 12:40'!
initializeForTeam: teamClass 
	| nRobots |
	nRobots := teamClass numberOfRobots.
	home := Array new: nRobots.
	opponent := Array new: nRobots.
	1
		to: nRobots
		do: [:i | 
			home at: i put: (teamClass robotClass new environment: self).
			opponent at: i put: teamClass opponentClass new].
	currentBall := teamClass ballClass new.
	lastBall :=teamClass ballClass new.! !

!RSEnvironment methodsFor: 'inverting field' stamp: 'Richo 6/22/2008 17:54'!
invertField
	self invertPosition: self currentBall.
	self invertPosition: self lastBall.
	self home
		do: [:r | 
			self invertPosition: r.
			self invertRotation: r].
	self opponent
		do: [:r | 
			self invertPosition: r.
			self invertRotation: r]! !

!RSEnvironment methodsFor: 'inverting field' stamp: 'Richo 6/22/2008 18:00'!
invertFieldIfYellowTeam
self decideTeam.
	isYellowTeam
		ifTrue: [self invertField]! !

!RSEnvironment methodsFor: 'inverting field' stamp: 'Richo 10/13/2009 16:31'!
invertPosition: aRobotOrBall 

	aRobotOrBall position: fieldBounds left + (fieldBounds right - aRobotOrBall position x) @ (fieldBounds bottom + (fieldBounds top - aRobotOrBall position y))! !

!RSEnvironment methodsFor: 'inverting field' stamp: 'Richo 6/22/2008 17:55'!
invertRotation: aRobot 
	"Suma 180 pero lo mantiene entre -180 y 180"
	aRobot rotation: aRobot rotation opposite! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/22/2008 17:49'!
isYellowTeam
^isYellowTeam ! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/22/2008 17:49'!
isYellowTeam: aBoolean
isYellowTeam := aBoolean! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
lastBall
	"Answer the value of lastBall"

	^ lastBall! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
lastBall: anObject
	"Set the value of lastBall"

	lastBall := anObject! !

!RSEnvironment methodsFor: 'accessing mementos' stamp: 'Richo 10/18/2009 17:13'!
lastEnvironment
 ^lastEnvironments isEmpty ifTrue: [self] ifFalse: [lastEnvironments last]! !

!RSEnvironment methodsFor: 'accessing mementos' stamp: 'Richo 10/18/2009 17:36'!
lastEnvironment: aSmallInteger 
	^lastEnvironments atLast: aSmallInteger ifAbsent: [self firstEnvironment]! !

!RSEnvironment methodsFor: 'accessing mementos' stamp: 'Richo 10/18/2009 17:35'!
lastEnvironmentAt: aSmallInteger 
	^lastEnvironments at: aSmallInteger ifAbsent: [self lastEnvironment]! !

!RSEnvironment methodsFor: 'accessing mementos' stamp: 'Richo 10/6/2009 17:48'!
lastEnvironments
^lastEnvironments ! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
opponent
	"Answer the value of opponent"

	^ opponent! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
opponent: anObject
	"Set the value of opponent"

	opponent := anObject! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 20:22'!
opponentAt: aSmallInteger

	^opponent at: aSmallInteger ! !

!RSEnvironment methodsFor: 'copying' stamp: 'Richo 10/6/2009 13:11'!
postCopy
super postCopy.
home := home collect: [:r | r copy environment: self].
opponent := opponent collect: [:r | r copy].
currentBall := currentBall copy.
lastBall := lastBall copy.
fieldBounds := fieldBounds copy.
goalBounds := goalBounds copy.
gameState := gameState copy.
whosBall := whosBall copy.
isYellowTeam := isYellowTeam copy.! !

!RSEnvironment methodsFor: 'remembering' stamp: 'Richo 10/6/2009 17:52'!
rememberYourself
lastEnvironments addLast: self copy.
lastEnvironments size > 2500 ifTrue: [lastEnvironments := lastEnvironments allButFirst]! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:54'!
whosBall
	"Answer the value of whosBall"

	^ whosBall! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:54'!
whosBall: anObject
	"Set the value of whosBall"

	whosBall := anObject! !

Object subclass: #RSGame
	instanceVariableNames: 'videoServer robotServer environment team process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

!RSGame class methodsFor: 'constants' stamp: 'Richo 7/14/2008 11:47'!
numberOfRobotsDefaultValue
^5! !

!RSGame methodsFor: 'actions' stamp: 'Richo 7/12/2008 22:46'!
disconnectAll

	self disconnectVideoServer.
	self disconnectRobotServer.
	self disconnectTeam! !

!RSGame methodsFor: 'actions' stamp: 'Richo 7/12/2008 22:47'!
disconnectRobotServer
	self stop.
	robotServer
		ifNotNil: [robotServer disconnect.
			robotServer := nil]! !

!RSGame methodsFor: 'actions' stamp: 'Richo 10/13/2009 16:09'!
disconnectTeam
	self stop.
	team
		ifNotNil: [team := nil. environment := nil]! !

!RSGame methodsFor: 'actions' stamp: 'Richo 7/12/2008 22:47'!
disconnectVideoServer
	self stop.
	videoServer
		ifNotNil: [videoServer disconnect.
			videoServer := nil]! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 3/31/2009 16:04'!
environment
	"Answer the value of environment"
	^ environment! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:40'!
initializeEnvironment
	environment := team class environmentClass newForTeam: team class! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 10/21/2009 14:42'!
isPaused
process notNil ifTrue: [^process isSuspended].
^false! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 10/20/2009 12:24'!
isStepping
^self isStopped not and: [self isPaused not]! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 10/21/2009 14:42'!
isStopped
process notNil ifTrue: [^process isTerminated].
^true
! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 7/12/2008 21:39'!
pause
process ifNotNil: [
	process suspend]! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 7/12/2008 21:41'!
robotServer
	"Answer the value of robotServer"

	^ robotServer! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 7/12/2008 21:41'!
robotServer: anObject
	"Set the value of robotServer"

	robotServer := anObject! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 10/21/2009 13:54'!
start
	videoServer ifNil: [^self error: 'Video server not selected'].
	robotServer ifNil: [^self error: 'Robot server not selected'].
	team ifNil: [^self error: 'Team not selected'].
	process
		ifNotNil: [process resume.
			^ self].
	process := [[true]
				whileTrue: [self step]]
				forkNamed: self class asString! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 10/18/2009 17:08'!
step
	
	videoServer storeDataOn: environment.
	environment invertFieldIfYellowTeam.
	team strategyFor: environment.
	robotServer sendMovesOf: environment home.
	environment rememberYourself.! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 7/12/2008 22:34'!
stop
	process
		ifNotNil: [process terminate. process := nil]! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 7/12/2008 21:41'!
team
	"Answer the value of team"

	^ team! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 3/23/2009 15:13'!
team: aTeam 
	"Carga el team y manda a inicializar el environment"
	team := aTeam.
	
	self initializeEnvironment! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 7/12/2008 21:41'!
videoServer
	"Answer the value of videoServer"

	^ videoServer! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 7/12/2008 21:41'!
videoServer: anObject
	"Set the value of videoServer"

	videoServer := anObject! !

Object subclass: #RSImagesHolder
	instanceVariableNames: 'blue yellow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:14'!
defaultBlue1
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:14'!
defaultBlue2
^(Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:15'!
defaultBlue3
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:15'!
defaultBlue4
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:15'!
defaultBlue5
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:29'!
defaultNoRobot
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294901760 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294901760 4294901760 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294901760 4294901760 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294901760 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:16'!
defaultYellow1
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:17'!
defaultYellow2
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:17'!
defaultYellow3
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:18'!
defaultYellow4
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:18'!
defaultYellow5
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!RSImagesHolder methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:32'!
blueImageAt: aNumber
^blue at: aNumber ifAbsent: [self class defaultNoRobot]! !

!RSImagesHolder methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:48'!
blueImageAt: aNumber put: aForm
^blue at: aNumber put: aForm! !

!RSImagesHolder methodsFor: 'initialize-release' stamp: 'Richo 10/13/2009 12:31'!
initialize
blue := {self class defaultBlue1. 
self class defaultBlue2.
self class defaultBlue3.
self class defaultBlue4.
self class defaultBlue5.}.
yellow := {self class defaultYellow1.
self class defaultYellow2.
self class defaultYellow3.
self class defaultYellow4.
self class defaultYellow5.}! !

!RSImagesHolder methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:32'!
yellowImageAt: aNumber
^yellow at: aNumber ifAbsent: [self class defaultNoRobot]! !

!RSImagesHolder methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:48'!
yellowImageAt: aNumber put: aForm
^yellow at: aNumber put: aForm! !

Object subclass: #RSOpponentRobot
	instanceVariableNames: 'rotation position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

!RSOpponentRobot methodsFor: 'initialization' stamp: 'Richo 6/23/2008 11:50'!
initialize
	rotation := RSAngle degrees: 0.
	position := 0 @ 0! !

!RSOpponentRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:52'!
position
	"Answer the value of position"

	^ position! !

!RSOpponentRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:52'!
position: anObject
	"Set the value of position"

	position := anObject! !

!RSOpponentRobot methodsFor: 'copying' stamp: 'Richo 10/6/2009 12:15'!
postCopy
super postCopy.
rotation := rotation copy.
position := position copy.! !

!RSOpponentRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:52'!
rotation
	"Answer the value of rotation"

	^ rotation! !

!RSOpponentRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:52'!
rotation: anObject
	"Set the value of rotation"

	rotation := anObject! !

Object subclass: #RSRobot
	instanceVariableNames: 'environment rotation position velocityLeft velocityRight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

!RSRobot methodsFor: 'accessing' stamp: 'Richo 3/31/2009 16:05'!
environment
	"Answer the value of environment"
	^ environment! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 3/31/2009 16:05'!
environment: aRSEnvironment 
	environment := aRSEnvironment! !

!RSRobot methodsFor: 'initialize-release' stamp: 'Richo 6/23/2008 11:50'!
initialize
	rotation := RSAngle degrees: 0.
	position := 0 @ 0.
	velocityLeft := 0.
	velocityRight := 0! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
position
	"Answer the value of position"

	^ position! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
position: anObject
	"Set the value of position"

	position := anObject! !

!RSRobot methodsFor: 'copying' stamp: 'Richo 10/6/2009 13:11'!
postCopy
super postCopy.
rotation := rotation copy.
position := position copy.
velocityLeft := velocityLeft copy.
velocityRight := velocityRight copy.
! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
rotation
	"Answer the value of rotation"

	^ rotation! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 7/5/2008 21:09'!
rotation: anObject 
	"Set the value of rotation"
rotation := anObject! !

!RSRobot methodsFor: 'printing' stamp: 'Richo 6/21/2008 19:49'!
velocityAsString	^ velocityLeft asString , ' ' , velocityRight asString! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
velocityLeft
	"Answer the value of velocityLeft"

	^ velocityLeft! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
velocityLeft: anObject
	"Set the value of velocityLeft"

	velocityLeft := anObject! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
velocityRight
	"Answer the value of velocityRight"

	^ velocityRight! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
velocityRight: anObject
	"Set the value of velocityRight"

	velocityRight := anObject! !

RSRobot subclass: #RSRobotExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Strategy-Example'!

!RSRobotExample methodsFor: 'goalkeeper' stamp: 'Richo 6/22/2008 21:59'!
beGoalkeeper
	(self position x - 90) abs > 5
		ifTrue: [^ self moveTo: 90 @ self position y].
	(self rotation
			diff: (RSAngle degrees: -90))
			> 5
		ifTrue: [^ self lookDown].
	self followBallInY! !

!RSRobotExample methodsFor: 'goalkeeper' stamp: 'Richo 6/22/2008 22:03'!
followBallInY
	| pelotaY dif speed |
	pelotaY := self environment currentBall position y.
	dif := pelotaY - self position y.
	speed := 125.
	pelotaY < 50 & (pelotaY > 30)
		ifTrue: [dif > 1
				ifTrue: ["Esta arriba"
					^ self velocityLeft: speed negated;
						 velocityRight: speed negated].
			dif < -1
				ifTrue: ["Esta abajo"
					^ self velocityLeft: speed;
						 velocityRight: speed]].
	^ self velocityLeft: 0;
		 velocityRight: 0! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:59'!
getAngle: aPoint 
	| ang |
	(self quadrant: aPoint)
			= 1
		ifTrue: [ang := self getAngleInQuadrant1: aPoint].
	(self quadrant: aPoint)
			= 2
		ifTrue: [ang := self getAngleInQuadrant2: aPoint].
	(self quadrant: aPoint)
			= 3
		ifTrue: [ang := self getAngleInQuadrant3: aPoint].
	(self quadrant: aPoint)
			= 4
		ifTrue: [ang := self getAngleInQuadrant4: aPoint].
	^ RSAngle degrees: ang! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
getAngleInQuadrant1: aPoint 
	| dx dy |
	dx := (aPoint x - self position x) abs.
	dy := (aPoint y - self position y) abs.
	dx = 0
		ifTrue: [^ 90.0].
	^ (dy / dx) arcTan radiansToDegrees! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
getAngleInQuadrant2: aPoint 
	^ 180
		- (self getAngleInQuadrant1: aPoint)! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
getAngleInQuadrant3: aPoint 
	^ (self getAngleInQuadrant2: aPoint) negated! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
getAngleInQuadrant4: aPoint 
	^ (self getAngleInQuadrant1: aPoint) negated! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
isInTheRightSide: aPoint 
	| miAng miOpuesto ang |
	miAng := self rotation.
	miOpuesto := miAng opposite.
	ang := self getAngle: aPoint.
	miAng degrees > 0
		ifTrue: [^ (ang > miAng | (ang < miOpuesto)) not]
		ifFalse: [^ ang < miAng | (ang > miOpuesto)]! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
isLookingTo: aPoint 
	^ (self lookInFrontOf: aPoint)
		| (self lookBackwardsTo: aPoint)! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
lookBackwardsTo: aPoint 
	| angulo |
	angulo := self getAngle: aPoint.
	^ (self rotation opposite diff: angulo)
		< 20! !

!RSRobotExample methodsFor: 'goalkeeper' stamp: 'Richo 6/22/2008 21:58'!
lookDown
	| direccion speed |
	direccion := self position x @ (self position y - 20).
	speed := 10.
	(self isInTheRightSide: direccion)
		ifTrue: [self velocityLeft: speed;
				 velocityRight: speed negated]
		ifFalse: [self velocityLeft: speed negated;
				 velocityRight: speed]! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:58'!
lookInFrontOf: aPoint 
	| angulo |
	angulo := self getAngle: aPoint.
	^ (self rotation diff: angulo)
		< 20! !

!RSRobotExample methodsFor: 'navigation' stamp: 'Richo 6/22/2008 21:58'!
moveTo: aPoint 
	(self lookInFrontOf: aPoint)
		ifTrue: [^ self velocityLeft: 125;
				 velocityRight: 125].
	(self lookBackwardsTo: aPoint)
		ifTrue: [^ self velocityLeft: -125;
				 velocityRight: -125].
	(self isInTheRightSide: aPoint)
		ifTrue: [self velocityLeft: 125;
				 velocityRight: 50]
		ifFalse: [self velocityLeft: 50;
				 velocityRight: 125]! !

!RSRobotExample methodsFor: 'navigation' stamp: 'Richo 6/22/2008 22:01'!
moveToBall
	| posPelota |
	posPelota := self environment currentBall position.
	self position x > posPelota x
		ifTrue: [self moveTo: posPelota]
		ifFalse: [self position y < posPelota y
				ifTrue: [self moveTo: posPelota x + 10 @ (posPelota y - 10)]
				ifFalse: [self moveTo: posPelota x + 10 @ (posPelota y + 10)]]! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:58'!
quadrant: aPoint 
	aPoint x >= self position x
		ifTrue: [aPoint y >= self position y
				ifTrue: [^ 1]
				ifFalse: [^ 4]]
		ifFalse: [aPoint y >= self position y
				ifTrue: [^ 2]
				ifFalse: [^ 3]]! !

Object subclass: #RSRobotServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers'!

RSRobotServer subclass: #RSNestorRobotServer
	instanceVariableNames: 'socket port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real'!

RSNestorRobotServer class
	instanceVariableNames: 'lastPort'!

RSNestorRobotServer class
	instanceVariableNames: 'lastPort'!

!RSNestorRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:26'!
fromUser
	| port |
	port := (FillInTheBlank request: 'Port:' initialAnswer: self lastPort asString) asInteger.
	^ self port: port! !

!RSNestorRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:26'!
lastPort
^lastPort ifNil: [6]! !

!RSNestorRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:20'!
new
^self shouldNotImplement! !

!RSNestorRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:26'!
port: portNumber
lastPort := portNumber.
^(self basicNew setPort: portNumber) initialize.! !

!RSNestorRobotServer methodsFor: 'converting' stamp: 'Richo 10/20/2009 11:17'!
adapt: aVelocity
^aVelocity >= 0
		ifTrue: [aVelocity]
		ifFalse: [aVelocity abs + 125]! !

!RSNestorRobotServer methodsFor: 'initialize-release' stamp: 'Richo 10/20/2009 11:23'!
disconnect
port close.
port := nil.! !

!RSNestorRobotServer methodsFor: 'accessing' stamp: 'Richo 10/20/2009 11:23'!
isConnected
^port notNil! !

!RSNestorRobotServer methodsFor: 'printing' stamp: 'Richo 10/20/2009 11:24'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '(' , port asString , ')'! !

!RSNestorRobotServer methodsFor: 'sending' stamp: 'Richo 10/20/2009 11:15'!
sendMovesOf: aCollectionOfRobots
| msg |
msg := aCollectionOfRobots collect: [:each|
	(Character value: (self adapt: each velocityLeft )) asString,
	(Character value: (self adapt: each velocityRight )) asString,
	(Character value: 0) asString
	].
port nextPutAll: msg.! !

!RSNestorRobotServer methodsFor: 'private' stamp: 'Richo 10/20/2009 11:22'!
setPort: portNumber
	port := SerialPort new
			baudRate: 9600;
			parityType: 0;
			dataBits: 8;
			openPort: portNumber! !

!RSRobotServer class methodsFor: 'instance creation' stamp: 'Richo 7/14/2008 12:48'!
fromUser
	"Pide los datos necesarios al usuario y crea el objeto cargando los datos
	necesarios"
	^ self subclassResponsibility! !

!RSRobotServer methodsFor: 'as yet unclassified' stamp: 'Richo 6/23/2008 11:05'!
sendMovesOf: aCollectionOfRobots
	"Enva la velocidad de las ruedas de todos los robots"
	self subclassResponsibility! !

RSRobotServer subclass: #RSSimulatedRobotServer
	instanceVariableNames: 'socket ip port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Simulated'!

RSSimulatedRobotServer class
	instanceVariableNames: 'lastIp lastPort'!

RSSimulatedRobotServer class
	instanceVariableNames: 'lastIp lastPort'!

!RSSimulatedRobotServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:49'!
fromUser
	| ip port |
	ip := FillInTheBlank request: 'IP:' initialAnswer: self lastIp.
	port := (FillInTheBlank request: 'Port:' initialAnswer: self lastPort asString) asInteger.
	^ self ip: ip port: port! !

!RSSimulatedRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:18'!
ip: aString port: aSmallInteger 
lastIp := aString.
lastPort := aSmallInteger.
^ (self basicNew setIp: aString setPort: aSmallInteger) initialize! !

!RSSimulatedRobotServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:49'!
lastIp
^lastIp ifNil: ['localhost']! !

!RSSimulatedRobotServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:49'!
lastPort
^lastPort ifNil: [6363]! !

!RSSimulatedRobotServer methodsFor: 'initialize-release' stamp: 'Richo 6/22/2008 17:44'!
disconnect

	socket closeAndDestroy! !

!RSSimulatedRobotServer methodsFor: 'initialize-release' stamp: 'Richo 6/23/2008 11:07'!
initialize
	socket := Socket newUDP.! !

!RSSimulatedRobotServer methodsFor: 'printing' stamp: 'Richo 7/12/2008 23:28'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '(' , ip , ', ' , port asString , ')'! !

!RSSimulatedRobotServer methodsFor: 'sending' stamp: 'Richo 6/26/2008 11:07'!
sendMovesOf: aCollectionOfRobots 
	| str |

	str := ''.
	aCollectionOfRobots
		do: [:r | str := str , r velocityAsString , ' '].
	socket
		sendData: str
		toHost: (NetNameResolver addressForName: ip)
		port: port! !

!RSSimulatedRobotServer methodsFor: 'private' stamp: 'Richo 6/21/2008 19:09'!
setIp: aString setPort: aSmallInteger 
ip:= aString.
port := aSmallInteger ! !

Object subclass: #RSTeam
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

!RSTeam class methodsFor: 'factory' stamp: 'Richo 10/13/2009 11:35'!
ballClass
^RSBall! !

!RSTeam class methodsFor: 'factory' stamp: 'Richo 10/13/2009 11:35'!
environmentClass
^RSEnvironment! !

!RSTeam class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:44'!
numberOfRobots
"Subclasses may override this method but they need to be careful to implement a corresponding video server and robot server. Otherwise it will not work"
^5! !

!RSTeam class methodsFor: 'factory' stamp: 'Richo 10/13/2009 11:35'!
opponentClass
^RSOpponentRobot! !

!RSTeam class methodsFor: 'factory' stamp: 'Richo 10/13/2009 11:35'!
robotClass
^RSRobot! !

!RSTeam methodsFor: 'strategy' stamp: 'Richo 7/12/2008 21:43'!
strategyFor: anEnvironment
	self subclassResponsibility! !

RSTeam subclass: #RSTeamExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Strategy-Example'!

!RSTeamExample class methodsFor: 'factory' stamp: 'Richo 10/13/2009 11:52'!
robotClass
^RSRobotExample! !

!RSTeamExample methodsFor: 'strategy' stamp: 'Richo 10/18/2009 17:35'!
strategyFor: env
env home
		do: [:r | r moveToBall].
	(env homeAt: 1) beGoalkeeper.
"	env home
		do: [:r | r velocityRight: 125; velocityLeft: -125]."
! !

RSTeam subclass: #RSTeamPerformance
	instanceVariableNames: 'times'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Strategy-Performance'!

!RSTeamPerformance methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 17:41'!
getAverage
^self getDiff average asFloat! !

!RSTeamPerformance methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 17:04'!
getDiff
	| aux diff |
	aux := times first.
	diff := OrderedCollection new.
	times allButFirst
		do: [:each | 
			diff add: each - aux.
			aux := each].
	^ diff ! !

!RSTeamPerformance methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 17:03'!
initialize
	super initialize.
	times := OrderedCollection new.
! !

!RSTeamPerformance methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 17:18'!
strategyFor: env 

	times add: Time millisecondClockValue.
	env home
		do: [:each | each velocityLeft: 125;
				 velocityRight: -125]! !

Object subclass: #RSVideoServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers'!

RSVideoServer subclass: #RSDoraemonVideoServer
	instanceVariableNames: 'socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real'!

RSDoraemonVideoServer class
	instanceVariableNames: 'lastPort'!

RSDoraemonVideoServer class
	instanceVariableNames: 'lastPort'!

!RSDoraemonVideoServer class methodsFor: 'instance creation' stamp: 'Richo 9/29/2009 17:19'!
fromUser
	^ RSDoraemonMorph new openInHand videoServer! !

!RSDoraemonVideoServer class methodsFor: 'instance creation' stamp: 'Richo 9/29/2009 09:52'!
lastPort
	^ lastPort
		ifNil: [6364]! !

!RSDoraemonVideoServer class methodsFor: 'instance creation' stamp: 'Richo 9/29/2009 09:52'!
port: aSmallInteger 
	lastPort := aSmallInteger.
	^ self basicNew
		setSocket: (Socket newUDP setPort: aSmallInteger)! !

!RSDoraemonVideoServer methodsFor: 'initialize-release' stamp: 'Richo 9/29/2009 17:21'!
disconnect
self isConnected ifTrue:[
	socket closeAndDestroy]! !

!RSDoraemonVideoServer methodsFor: 'receiving' stamp: 'Richo 9/29/2009 09:51'!
getData
	| data |
	data := String new: 512.
	socket waitForData; receiveDataInto: data.
	^ data! !

!RSDoraemonVideoServer methodsFor: 'testing' stamp: 'Richo 9/29/2009 17:21'!
isConnected
^socket notNil! !

!RSDoraemonVideoServer methodsFor: 'printing' stamp: 'Richo 9/29/2009 17:21'!
printOn: aStream 
	super printOn: aStream.
self isConnected ifTrue:[
	aStream nextPutAll: '(' , socket port asString , ')']! !

!RSDoraemonVideoServer methodsFor: 'private' stamp: 'Richo 9/29/2009 09:52'!
setSocket: aSocket 
	socket := aSocket! !

!RSDoraemonVideoServer methodsFor: 'parsing' stamp: 'Richo 10/20/2009 11:27'!
storeDataOn: env 
! !

!RSDoraemonVideoServer methodsFor: 'parsing' stamp: 'Richo 10/20/2009 11:27'!
storeDataOnViejo: env 
	"Cuando no encuentro la pelota o al robot debera predecir adonde podra
	estar. Por ahora no hace nada"
	| data parser variable resultado robot |
	data := self getData.
	parser := TextDiffBuilder new.
	variable := parser split: data by: Character lf.
	resultado := variable
				collect: [:each | parser split: each by: Character space].
	((resultado at: 3)
			at: 3)
			= 'Found'
		ifTrue: [env currentBall position: ((resultado at: 3)
					at: 4) asNumber @ ((resultado at: 3)
						at: 5) asNumber.
].
	1
		to: 3
		do: [:i | ((resultado at: i + 3)
					at: 3)
					= 'Found'
				ifTrue: [robot := env home at: i.
					robot position: ((resultado at: i + 3)
							at: 4) asNumber @ ((resultado at: i + 3)
								at: 5) asNumber.
					robot
						rotation: (RSAngle radians: ((resultado at: i + 3)
									at: 7) asNumber)]]! !

RSVideoServer subclass: #RSSimulatedVideoServer
	instanceVariableNames: 'socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Simulated'!

RSSimulatedVideoServer class
	instanceVariableNames: 'lastPort'!

RSSimulatedVideoServer class
	instanceVariableNames: 'lastPort'!

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:27'!
anyonesBall
	^ 0! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:27'!
blueBall
	^ 1! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 4/1/2009 14:20'!
fieldBounds
	^ ( 6.8118@ 77.2392) corner: ( 93.4259@ 6.373)
! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
freeBall
	^ 1! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
freeKick
	^ 4! !

!RSSimulatedVideoServer class methodsFor: 'instance creation' stamp: 'Richo 7/14/2008 10:22'!
fromUser
	| port |
	port := (FillInTheBlank request: 'Port:' initialAnswer: self lastPort asString) asInteger.

	^ self port: port! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 4/1/2009 14:21'!
goalBounds
^ 2.8748 @ 49.6801 corner:  97.3632@ 33.932
! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
goalKick
	^ 5! !

!RSSimulatedVideoServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:47'!
lastPort
^lastPort ifNil: [6364]! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
penaltyKick
	^ 3! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
placeKick
	^ 2! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:29'!
playersPerSide
	^ 5! !

!RSSimulatedVideoServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:48'!
port: aSmallInteger 
lastPort := aSmallInteger.
	^ self basicNew
		setSocket: (Socket newUDP setPort: aSmallInteger)! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:29'!
yellowBall
	^ 2! !

!RSSimulatedVideoServer methodsFor: 'initialize-release' stamp: 'Richo 6/21/2008 18:58'!
disconnect
	socket closeAndDestroy! !

!RSSimulatedVideoServer methodsFor: 'receiving' stamp: 'Richo 6/21/2008 18:43'!
getData
	| data |
	data := String new: 512.
	socket waitForData; receiveDataInto: data.
	^data! !

!RSSimulatedVideoServer methodsFor: 'printing' stamp: 'Richo 7/12/2008 23:31'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '(' , socket port asString , ')'! !

!RSSimulatedVideoServer methodsFor: 'private' stamp: 'Richo 6/21/2008 19:06'!
setSocket: aSocket 
socket := aSocket! !

!RSSimulatedVideoServer methodsFor: 'parsing' stamp: 'Richo 10/13/2009 16:37'!
storeDataOn: env 
	| data parser variable resultado i translateFactor |
	data := self getData.
	parser := TextDiffBuilder new.
	variable := parser split: data by: Character lf.
	resultado := variable
				collect: [:each | parser split: each by: Character space].
	env lastBall position: env currentBall position x @ env currentBall position y.
	env currentBall position: ((resultado at: 1)
			at: 1) asNumber @ ((resultado at: 1)
				at: 2) asNumber.
	i := 1.
	env home
		do: [:robot | 
			robot position: ((resultado at: i + 1)
					at: 1) asNumber @ ((resultado at: i + 1)
						at: 2) asNumber.
			robot
				rotation: (RSAngle degrees: ((resultado at: i + 1)
							at: 4) asNumber).
			i := i + 1].
	i := 1.
	env opponent
		do: [:opponent | 
			opponent position: ((resultado at: i + 6)
					at: 1) asNumber @ ((resultado at: i + 6)
						at: 2) asNumber.
			opponent
				rotation: (RSAngle degrees: ((resultado at: i + 6)
							at: 4) asNumber).
			i := i + 1].
	env gameState: ((resultado at: 12)
			at: 1) asNumber.
	env whosBall: ((resultado at: 12)
			at: 2) asNumber.
	"The #translateBy: message fixes an error in the drawing. I hope this doesn't cause any trouble"
	translateFactor := env isYellowTeam isNil ifTrue: [0@0] ifFalse: [(env isYellowTeam ifTrue: [0@-1] ifFalse: [0@1])].
	env
		fieldBounds: (self class fieldBounds translateBy: translateFactor).
	env
		goalBounds: (self class goalBounds)! !

!RSVideoServer class methodsFor: 'instance creation' stamp: 'Richo 6/22/2008 17:42'!
fromUser
"Devuelve la conexin al servidor de video"
	^ self subclassResponsibility! !

!RSVideoServer methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2008 17:53'!
storeDataOn: anEnvironment 
	"Recibe los datos, los parsea y los carga en el environment
	Datos que debera cargar en el environment:
	- home (Coleccin de RSRobot - Posicin y rotacin de cada robot
	propio). 
	- opponent (Coleccin de RSOpponentRobot - Posicin y rotacin
	de cada robot contrario).
	- currentBall (RSBall - Posicin de la pelota en este momento).
	- lastBall (RSBall - ltima posicin de la pelota).
	- fieldBounds (Rectangle - Lmites de la cancha).
	- goalBounts (Rectangle - Lmites de los arcos).
	- gameState (?).
	- whosBall (?).
	"
	self subclassResponsibility! !

Object subclass: #RSViewerPlugin
	instanceVariableNames: 'viewer isActive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

RSViewerPlugin subclass: #RSImagesHolderPlugin
	instanceVariableNames: 'blueImageList yellowImageList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!RSImagesHolderPlugin class methodsFor: 'as yet unclassified' stamp: 'Richo 10/21/2009 14:27'!
priority
^0.6! !

!RSImagesHolderPlugin methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:40'!
blueImageList

^blueImageList ifNil: [blueImageList := AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 hResizing: #shrinkWrap;
		 wrapCentering: #center.]
	! !

!RSImagesHolderPlugin methodsFor: 'initializing' stamp: 'Richo 10/13/2009 15:36'!
initialize
super initialize.
1 to: 5 do: [:i|
	self blueImageList addMorphBack: (SketchMorph withForm: (viewer imagesHolder blueImageAt: i)).
	self yellowImageList addMorphBack: (SketchMorph withForm: (viewer imagesHolder yellowImageAt: i))
	]! !

!RSImagesHolderPlugin methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:41'!
menu
	| actButton menu |
menu := AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center; 
"		addMorphBack: 'Robot''s images: ' asMorph;"
		addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		addMorphBack: self yellowImageList;
		addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		addMorphBack: self blueImageList;
		addMorphBack: AlignmentMorph newVariableTransparentSpacer.
"	actButton := SimpleButtonMorph new label: ' Activate ';
				color: (Color green mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised;
				 borderWidth: 2.
	menu addMorphBack: (actButton actionSelector: #value;
			
			target: [self toggleActivateDeactivate.
				isActive
					ifTrue: [actButton color: (Color red mixed: 0.3 with: Color blue muchLighter);
							 label: ' Deactivate ']
					ifFalse: [actButton color: (Color green mixed: 0.3 with: Color blue muchLighter);
							 label: ' Activate ']])."
	^ menu
! !

!RSImagesHolderPlugin methodsFor: 'stepping' stamp: 'Richo 10/13/2009 15:34'!
step
! !

!RSImagesHolderPlugin methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:40'!
yellowImageList

^yellowImageList ifNil: [yellowImageList := AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 hResizing: #shrinkWrap;
		 wrapCentering: #center.]
	! !

RSViewerPlugin subclass: #RSReplayPlugin
	instanceVariableNames: 'currentEnvIndex isPlaying'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!RSReplayPlugin class methodsFor: 'as yet unclassified' stamp: 'Richo 10/21/2009 14:27'!
priority
^0.6! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/21/2009 14:06'!
activate 
isActive ifTrue: [^self].
isActive := true.
currentEnvIndex := self environmentsCount.
viewer pause.! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/21/2009 14:01'!
deactivate 
isActive := false.! !

!RSReplayPlugin methodsFor: 'accessing' stamp: 'Richo 10/18/2009 17:28'!
environmentsCount
^[viewer game environment lastEnvironments size] on: Error do: [1]! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/21/2009 13:59'!
goToFirst
self activate.
currentEnvIndex := 1! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/21/2009 13:59'!
goToLast
self activate.
currentEnvIndex := self environmentsCount! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/21/2009 13:59'!
goToNext
self activate.
currentEnvIndex := currentEnvIndex + 1 min: self environmentsCount.! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/21/2009 13:59'!
goToPrevious
self activate.
currentEnvIndex := currentEnvIndex - 1 max: 1! !

!RSReplayPlugin methodsFor: 'stepping' stamp: 'Richo 10/21/2009 14:17'!
increaseIndex
	currentEnvIndex := currentEnvIndex + 1.
	currentEnvIndex > self environmentsCount 
		ifTrue: [currentEnvIndex := self environmentsCount . isPlaying := false]! !

!RSReplayPlugin methodsFor: 'initializing' stamp: 'Richo 10/21/2009 14:21'!
initialize
super initialize.
currentEnvIndex := 1.
isPlaying := false.! !

!RSReplayPlugin methodsFor: 'accessing' stamp: 'Richo 10/21/2009 14:21'!
menu
	^AlignmentMorph newRow color: Color transparent;
				 cornerStyle: #rounded;
				 borderWidth: 0;
				 layoutInset: 3;
				 vResizing: #shrinkWrap;
				 wrapCentering: #center;
				addMorphBack: AlignmentMorph newVariableTransparentSpacer ;

				 addMorphBack: (SimpleButtonMorph new label: ' << First ';
					
						
					color:   (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					 borderWidth: 2;
					 actionSelector: #goToFirst; 
					 target: self);
				 addMorphBack: (SimpleButtonMorph new label: ' < Previous ';
										
					color:   (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					 borderWidth: 2;
					 actionSelector: #goToPrevious;
					 actWhen: #whilePressed;
					 target: self);
				 addMorphBack: (SimpleButtonMorph new label: ' - Play from here - ';
						
					color:  (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					 borderWidth: 2;
					 actionSelector: #play;
					 actWhen: #buttonDown;
					 target: self);
				 addMorphBack: (SimpleButtonMorph new label: ' Next > ';
						
					color:   (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					 borderWidth: 2;
					 actionSelector: #goToNext;
					 actWhen: #whilePressed;
					 target: self);
				 addMorphBack: (SimpleButtonMorph new label: ' Last >> ';
						
					color:   (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					 borderWidth: 2;
					 actionSelector: #goToLast;
					 target: self);
									addMorphBack: AlignmentMorph newVariableTransparentSpacer .! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/21/2009 14:15'!
play
isPlaying := true! !

!RSReplayPlugin methodsFor: 'stepping' stamp: 'Richo 10/21/2009 14:16'!
step
viewer gameState = #run ifTrue: [^self deactivate].
viewer currentEnv: (viewer game environment lastEnvironmentAt: currentEnvIndex).
isPlaying ifTrue: [self increaseIndex]! !

!RSViewerPlugin class methodsFor: 'instance creation' stamp: 'Richo 10/13/2009 12:05'!
on: aRSViewerMorph
^(self basicNew setViewer: aRSViewerMorph ) initialize! !

!RSViewerPlugin class methodsFor: 'constants' stamp: 'Richo 10/18/2009 17:24'!
priority
"Subclasses should change this value if they need to execute themselves in a specific order. Higher number means higher priority.

Range 0.0 ... 1.0"
^0.5! !

!RSViewerPlugin methodsFor: 'initializing' stamp: 'Richo 10/13/2009 12:06'!
initialize
isActive := false! !

!RSViewerPlugin methodsFor: 'initializing' stamp: 'Richo 10/13/2009 12:07'!
menu
	"Debe devolver un menu para activar/desactivar el plugin"
	self subclassResponsibility! !

!RSViewerPlugin methodsFor: 'private' stamp: 'Richo 10/13/2009 12:06'!
setViewer: aRSViewerMorph
	viewer := aRSViewerMorph ! !

!RSViewerPlugin methodsFor: 'stepping' stamp: 'Richo 10/13/2009 12:06'!
step
self subclassResponsibility! !

!RSViewerPlugin methodsFor: 'stepping' stamp: 'Richo 10/13/2009 12:06'!
stepIfActive
	isActive ifTrue: [self step]! !

!RSViewerPlugin methodsFor: 'activation' stamp: 'Richo 10/20/2009 12:42'!
toggleActivateDeactivate
	isActive := isActive not.! !

Morph subclass: #RSBoardMorph
	instanceVariableNames: 'ball home opponent imagesHolder gameState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

RSBoardMorph class
	instanceVariableNames: 'form'!

RSBoardMorph class
	instanceVariableNames: 'form'!

!RSBoardMorph class methodsFor: 'form' stamp: 'Richo 10/9/2009 15:57'!
form
	^ form
		ifNil: [self initializeForm]! !

!RSBoardMorph class methodsFor: 'form' stamp: 'Richo 10/9/2009 15:58'!
initializeForm
^form := (Form
	extent: 675@500
	depth: 1
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294966784 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4194303 4294967295 4294967295 3758096384 4294967295 4294967295 4294966272 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1048575 4294967295 4294967295 3758096384 4294967295 4294967295 4294965375 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278714367 4294967295 4294967295 3758096384 4294967295 4294967295 4294963455 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286840831 4294967295 4294967295 3758096384 4294967295 4294967295 4294959615 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290904063 4294967295 4294967295 3758096384 4294967295 4294967295 4294951935 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292935679 4294967295 4294967295 3758096384 4294967295 4294967295 4294936575 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293951487 4294967295 4294967295 3758096384 4294967295 4294967295 4294905855 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294459391 4294967295 4294967295 3758096384 4294967295 4294967295 4294844415 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294713343 4294967295 4294967295 3758096384 4294967295 4294967295 4294721535 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294840319 4294967295 4294967295 3758096384 4294967295 4294967295 4294475775 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294903807 4294967295 4294967295 3758096384 4294967295 4294967295 4293984255 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294935551 4294967295 4294967295 3758096384 4294967295 4294967295 4293001215 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294951423 4294967295 4294967295 3758096384 4294967295 4294967295 4291035135 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294959359 4294967295 4294967295 3758096384 4294967295 4294967295 4287102975 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294963327 4294967295 4294967295 3758096384 4294967295 4294967295 4279238655 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294965311 4294967295 4294967295 3758096384 4294967295 4294967295 4263510015 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966303 4294967295 4294967295 3758096384 4294967295 4294967295 4232052735 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966799 4294967295 4294967295 3758096384 4294967295 4294967295 4169138175 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967047 4294967295 4294967295 3758096384 4294967295 4294967295 4043309055 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967171 4294967295 4294967295 3758096384 4294967295 4294967295 3791650815 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967233 4294967295 4294967295 3758096384 4294967295 4294967295 3288334335 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967264 4294967295 4294967295 3758096384 4294967295 4294967295 2281701375 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967280 2147483647 4294967295 3758096384 4294967295 4294967295 268435455 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967288 1073741823 4294967295 3758096384 4294967295 4294967294 536870911 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967292 536870911 4294967295 3758096384 4294967295 4294967292 1073741823 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967294 268435455 4294967295 3758096384 4294967295 4294967288 2147483647 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 134217727 4294967295 3758096384 4294967295 4294967288 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 2281701375 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4169138175 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967055 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4030726143 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966791 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4030726143 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966791 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4169138175 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967055 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967288 0 0 1023 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4292870144 0 0 134217727 4294967295 3758096384 4294967295 4294967288 0 0 1023 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4292870144 0 0 134217727 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967288 0 268435455 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967288 0 134217727 4294967295 3758096384 4294967295 4294967288 0 268435455 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4278190207 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967288 0 134217727 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 3221225473 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967292 16727936 536870911 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967264 1073692670 67108863 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967043 4294918143 3766484991 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294966303 4294918143 4229955583 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294963327 4294918143 4278714367 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294951935 4294918143 4293001215 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294905855 4294918143 4294475775 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294852607 4294918143 4294852607 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294475775 4294918143 4294905855 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294049791 4294918143 4294952959 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294966784 1 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4291035135 4294918143 4294959615 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3758096384 4194303 3758096384 4294966784 1 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4287627263 4294918143 4294965503 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3758096384 4194303 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4280287231 4294918143 4294966399 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4232052735 4294918143 4294966815 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4177526783 4294918143 4294967183 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4060086271 4294918143 4294967239 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 3825205247 4294918143 4294967267 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 3355443199 4294918143 4294967281 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 2415919103 4294918143 4294967288 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 2684354559 4294918143 4294967292 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 1073741823 4294918143 4294967294 2147483647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967294 1073741823 4294918143 4294967294 1073741823 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967292 2147483647 4294918143 4294967295 536870911 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967292 4294967295 4294918143 4294967295 2684354559 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967289 4294967295 4294918143 4294967295 3489660927 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967281 4294967295 4294918143 4294967295 3355443199 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967283 4294967295 4294918143 4294967295 3892314111 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967271 4294967295 4294918143 4294967295 4093640703 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967239 4294967295 4294918143 4294967295 4060086271 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967247 4294967295 4294918143 4294967295 4194303999 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967199 4294967295 4294918143 4294967295 4244635647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967199 4294967295 4294918143 4294967295 4244635647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967103 4294967295 4294918143 4294967295 4269801471 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967103 4294967295 4294918143 4294967295 4269801471 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966911 4294967295 4294918143 4294967295 4282384383 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966911 4294967295 4294918143 4294967295 4282384383 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966399 4294967295 4294918143 4294967295 4280287231 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966527 4294967295 4294918143 4294967295 4288675839 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966527 4294967295 4294918143 4294967295 4288675839 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964103 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4041736191 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963971 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3764912127 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963833 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3475505151 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963833 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3475505151 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963833 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3475505151 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963833 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3475505151 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963971 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3764912127 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964103 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4041736191 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294705151 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294705151 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966527 4294967295 4294918143 4294967295 4288675839 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966527 4294967295 4294918143 4294967295 4288675839 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966399 4294967295 4294918143 4294967295 4280287231 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966911 4294967295 4294918143 4294967295 4282384383 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966911 4294967295 4294918143 4294967295 4282384383 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967103 4294967295 4294918143 4294967295 4269801471 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967103 4294967295 4294918143 4294967295 4269801471 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967199 4294967295 4294918143 4294967295 4244635647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967199 4294967295 4294918143 4294967295 4244635647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967247 4294967295 4294918143 4294967295 4194303999 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967239 4294967295 4294918143 4294967295 4060086271 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967271 4294967295 4294918143 4294967295 4093640703 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967283 4294967295 4294918143 4294967295 3892314111 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967281 4294967295 4294918143 4294967295 3355443199 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967289 4294967295 4294918143 4294967295 3489660927 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967292 4294967295 4294918143 4294967295 2684354559 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967292 2147483647 4294918143 4294967295 536870911 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967294 1073741823 4294918143 4294967294 1073741823 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 1073741823 4294918143 4294967294 2147483647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 2684354559 4294918143 4294967292 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 2415919103 4294918143 4294967288 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 3355443199 4294918143 4294967281 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 3825205247 4294918143 4294967267 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4060086271 4294918143 4294967239 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4177526783 4294918143 4294967183 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4232052735 4294918143 4294966815 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4280287231 4294918143 4294966399 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4287627263 4294918143 4294965503 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966784 1 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4291035135 4294918143 4294959615 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3758096384 4194303 3758096384 4294966784 1 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294049791 4294918143 4294952959 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3758096384 4194303 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294475775 4294918143 4294905855 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294852607 4294918143 4294852607 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294905855 4294918143 4294475775 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294951935 4294918143 4293001215 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294963327 4294918143 4278714367 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294966303 4294918143 4229955583 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967043 4294918143 3766484991 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967264 1073692670 67108863 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967292 16727936 536870911 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 3221225473 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967288 0 268435455 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4278190207 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967288 0 134217727 4294967295 3758096384 4294967295 4294967288 0 268435455 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967288 0 134217727 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967288 0 0 1023 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4292870144 0 0 134217727 4294967295 3758096384 4294967295 4294967288 0 0 1023 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4292870144 0 0 134217727 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4169138175 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967055 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4030726143 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966791 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4030726143 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966791 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4169138175 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967055 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3355443199 4294967295 3758096384 4294967295 4294967288 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 2281701375 4294967295 3758096384 4294967295 4294967292 2147483647 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 268435455 4294967295 3758096384 4294967295 4294967294 1073741823 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967294 536870911 4294967295 3758096384 4294967295 4294967295 536870911 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967292 1073741823 4294967295 3758096384 4294967295 4294967295 2415919103 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967288 2147483647 4294967295 3758096384 4294967295 4294967295 3355443199 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967280 4294967295 4294967295 3758096384 4294967295 4294967295 3825205247 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967265 4294967295 4294967295 3758096384 4294967295 4294967295 4060086271 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967235 4294967295 4294967295 3758096384 4294967295 4294967295 4177526783 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967175 4294967295 4294967295 3758096384 4294967295 4294967295 4236247039 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967055 4294967295 4294967295 3758096384 4294967295 4294967295 4265607167 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966815 4294967295 4294967295 3758096384 4294967295 4294967295 4280287231 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966335 4294967295 4294967295 3758096384 4294967295 4294967295 4287627263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294965375 4294967295 4294967295 3758096384 4294967295 4294967295 4291297279 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294963455 4294967295 4294967295 3758096384 4294967295 4294967295 4293132287 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294959615 4294967295 4294967295 3758096384 4294967295 4294967295 4294049791 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294951935 4294967295 4294967295 3758096384 4294967295 4294967295 4294508543 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294936575 4294967295 4294967295 3758096384 4294967295 4294967295 4294737919 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294905855 4294967295 4294967295 3758096384 4294967295 4294967295 4294852607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294844415 4294967295 4294967295 3758096384 4294967295 4294967295 4294909951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294721535 4294967295 4294967295 3758096384 4294967295 4294967295 4294938623 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294475775 4294967295 4294967295 3758096384 4294967295 4294967295 4294952959 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293984255 4294967295 4294967295 3758096384 4294967295 4294967295 4294960127 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293001215 4294967295 4294967295 3758096384 4294967295 4294967295 4294963711 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291035135 4294967295 4294967295 3758096384 4294967295 4294967295 4294965503 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287102975 4294967295 4294967295 3758096384 4294967295 4294967295 4294966399 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4279238655 4294967295 4294967295 3758096384 4294967295 4294967295 4294966847 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4263510015 4294967295 4294967295 3758096384 4294967295 4294967295 4294966784 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4194303 4294967295 4294967295 3758096384 4294967295 4294967295 4294967040 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 8388607 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384)
	offset: 0@0)! !

!RSBoardMorph class methodsFor: 'conversion' stamp: 'Richo 10/9/2009 17:35'!
squeakAngle: robotSoccerAngle 
| angN dif |
angN := 90 - robotSoccerAngle.
angN>180 ifTrue:[
	dif := angN - 180.
	angN := -180 + dif.
	
	].
^angN! !

!RSBoardMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 14:17'!
ball
	ball
		isNil ifTrue: [self addMorph: (ball := RSBallMorph new)].
	^ ball! !

!RSBoardMorph methodsFor: 'drawing environment' stamp: 'Richo 10/13/2009 14:20'!
draw: env 
"I draw the environment and refresh the event handling to inspect the current objects"
	| i r |
	self
		setPositionOf: (self ball
				on: #mouseDown
				send: #inspect
				to: env currentBall)
		accordingTo: env currentBall
		in: env.
	i := 1.
	(self homeFor: env)
		do: [:each | 
			r := env homeAt: i.
			self
				setPositionOf: each
				accordingTo: r
				in: env.
			each
				heading: (self class squeakAngle: r rotation degrees);
				
				on: #mouseDown
				send: #inspect
				to: r.
			i := i + 1].
	i := 1.
	(self opponentFor: env)
		do: [:each | 
			r := env opponentAt: i.
			self
				setPositionOf: each
				accordingTo: r
				in: env.
			each
				heading: (self class squeakAngle: r rotation degrees);
				
				on: #mouseDown
				send: #inspect
				to: r.
			i := i + 1]! !

!RSBoardMorph methodsFor: 'drawing' stamp: 'Richo 10/9/2009 16:00'!
drawOn: aCanvas
	aCanvas drawImage: self class form at: self topLeft! !

!RSBoardMorph methodsFor: 'accessing' stamp: 'Richo 10/9/2009 16:53'!
fieldBounds
^self bounds topLeft + (61@24) corner: (self bounds topLeft + (612@475))! !

!RSBoardMorph methodsFor: 'game state' stamp: 'Richo 10/21/2009 14:31'!
gameState: aSymbol
"aSymbol may be one of the following:
#wait - It means is waiting for the game to start.
#stop
#pause
#run"
| newContents newColor |
newContents := ''.
newColor := Color transparent.
aSymbol = #wait ifTrue: [newContents := 'Waiting for connection ...'. newColor := Color white].
aSymbol = #stop ifTrue: [newContents := 'Stopped'. newColor := Color red].
aSymbol = #pause ifTrue: [newContents := 'Paused'. newColor := Color yellow].
aSymbol = #run ifTrue: [newContents := 'Running...'. newColor := Color green].
gameState contents = newContents ifFalse: [gameState contents: newContents].
gameState color = newColor ifFalse: [gameState color: newColor].! !

!RSBoardMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 14:19'!
homeFor: env 
	"Arreglar eso para luego poder elegir las imgenes de cada robot"
	home isNil
		ifTrue: [env isYellowTeam
				ifTrue: [home := (1 to: env home size)
								collect: [:i | RSRobotMorph
										withForm: (imagesHolder yellowImageAt: i)]]
				ifFalse: [home := (1 to: env home size)
								collect: [:i | RSRobotMorph
										withForm: (imagesHolder blueImageAt: i)]].
			home
				do: [:r | self addMorph: r]].
	^ home! !

!RSBoardMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:23'!
imagesHolder
^imagesHolder! !

!RSBoardMorph methodsFor: 'initialize' stamp: 'Richo 10/21/2009 13:35'!
initialize
	super initialize.
	self
		extent: (self class form extent);
		 cornerStyle: #rounded.
	imagesHolder := RSImagesHolder new.
	gameState := '' asString asMorph font: Preferences windowTitleFont;
		 color: Color red.
	self addMorph: (gameState topLeft: self topLeft + (5@2)).! !

!RSBoardMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 14:19'!
opponentFor: env 
	"Arreglar eso para luego poder elegir las imgenes de cada robot"
	opponent isNil
		ifTrue: [env isYellowTeam
				ifTrue: [opponent := (1 to: env opponent size)
								collect: [:i | RSRobotMorph
										withForm: (imagesHolder blueImageAt: i)]]
				ifFalse: [opponent := (1 to: env opponent size)
								collect: [:i | RSRobotMorph
										withForm: (imagesHolder yellowImageAt: i)]].
			opponent
				do: [:r | self addMorph: r]].
	^ opponent! !

!RSBoardMorph methodsFor: 'drawing environment' stamp: 'Richo 10/13/2009 11:57'!
setPositionOf: aMorph accordingTo: anObject in: anEnvironment
|differenceWithCenter pixelDifference|
differenceWithCenter := anObject position - anEnvironment fieldBounds center.
differenceWithCenter := differenceWithCenter x @ (differenceWithCenter y * -1).
pixelDifference := differenceWithCenter * self fieldBounds width / anEnvironment fieldBounds width.
aMorph center: self fieldBounds center + pixelDifference! !

Morph subclass: #RSDoraemonMorph
	instanceVariableNames: 'videoServer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real'!

RSDoraemonMorph class
	instanceVariableNames: 'videoServer'!

RSDoraemonMorph class
	instanceVariableNames: 'videoServer'!

!RSDoraemonMorph methodsFor: 'initialize-release' stamp: 'Richo 9/29/2009 17:20'!
initialize
	super initialize.
	videoServer := RSDoraemonVideoServer new! !

!RSDoraemonMorph methodsFor: 'accessing' stamp: 'Richo 9/29/2009 17:20'!
videoServer
	^ videoServer! !

Morph subclass: #RSRobotMorph
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!RSRobotMorph class methodsFor: 'instance creation' stamp: 'Richo 10/9/2009 18:00'!
new
self shouldNotImplement.
! !

!RSRobotMorph class methodsFor: 'instance creation' stamp: 'Richo 10/13/2009 10:35'!
withForm: aForm
^(self basicNew setForm: aForm) initialize! !

!RSRobotMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:33'!
center
(self owner isMemberOf: TransformationMorph)
ifTrue:[^self owner center].
^super center
! !

!RSRobotMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:33'!
center: aPoint 
"Para mantener las coordenadas correctas si el robot gira"
	(self owner isMemberOf: TransformationMorph)
		ifTrue: [^ self owner center: aPoint].
	^ super center: aPoint! !

!RSRobotMorph methodsFor: 'drawing' stamp: 'Richo 10/13/2009 10:35'!
drawOn: aCanvas
aCanvas translucentImage: form at: self bounds topLeft! !

!RSRobotMorph methodsFor: 'initialize' stamp: 'Richo 10/13/2009 10:35'!
initialize
super initialize.
self extent: form extent! !

!RSRobotMorph methodsFor: 'private' stamp: 'Richo 10/13/2009 10:34'!
setForm: aForm
form := aForm! !

AlignmentMorph subclass: #RSViewerMorph
	instanceVariableNames: 'board game plugins currentEnv'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!RSViewerMorph class methodsFor: 'parts bin' stamp: 'Richo 10/13/2009 12:22'!
descriptionForPartsBin
	^ self
		partName: 'Robot Soccer Viewer'
		categories: #('Robot Soccer' )
		documentation: ''! !

!RSViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/18/2009 17:23'!
addPluginList

	plugins := (RSViewerPlugin allSubclasses asArray sort: [:a :b | a priority >= b priority])
				collect: [:each | each on: self].
	plugins
				do: [:each | self addMorphBack: each menu].! !

!RSViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:08'!
board
^board! !

!RSViewerMorph methodsFor: 'robot server connection' stamp: 'Richo 10/21/2009 13:25'!
chooseRobotServerClass
	| choice robotServers strRobotServers |
	robotServers := RSRobotServer allSubclasses asArray sort: [:a :b | a name < b name].
	strRobotServers := robotServers
				collect: [:each | '  ' , each asString , '  '].
	choice := PopUpMenu withCaption: 'RobotServers:' chooseFrom: strRobotServers.
	choice = 0
		ifTrue: [^ nil].
	^robotServers at: choice! !

!RSViewerMorph methodsFor: 'team connection' stamp: 'Richo 10/21/2009 13:24'!
chooseTeamClass
	| teams strTeams choice |
		
	teams := RSTeam allSubclasses asArray sort: [:a :b | a name < b name].
	strTeams := teams
				collect: [:each | '  ' , each asString , '  '].
	choice := PopUpMenu withCaption: 'Teams:' chooseFrom: strTeams.
	choice = 0
		ifTrue: [^ nil].
	^ teams at: choice! !

!RSViewerMorph methodsFor: 'video server connection' stamp: 'Richo 10/21/2009 13:25'!
chooseVideoServerClass
	| choice videoServers strVideoServers |
	videoServers := RSVideoServer allSubclasses asArray sort: [:a :b | a name < b name].
	strVideoServers := videoServers
				collect: [:each | '  ' , each asString , '  '].
	choice := PopUpMenu withCaption: 'VideoServers:' chooseFrom: strVideoServers.
	choice = 0
		ifTrue: [^ nil].
	^videoServers at: choice! !

!RSViewerMorph methodsFor: 'robot server connection' stamp: 'Richo 10/13/2009 11:07'!
connectRobotServer
| robotServerClass |
robotServerClass := self chooseRobotServerClass.
robotServerClass ifNotNil: [
	game robotServer: robotServerClass fromUser.
	]! !

!RSViewerMorph methodsFor: 'team connection' stamp: 'Richo 10/13/2009 11:10'!
connectTeam
	| teamClass |
	teamClass := self chooseTeamClass.
teamClass
		ifNotNil: [game team: teamClass new]! !

!RSViewerMorph methodsFor: 'video server connection' stamp: 'Richo 10/13/2009 11:07'!
connectVideoServer
| videoServerClass |
videoServerClass := self chooseVideoServerClass.
videoServerClass ifNotNil: [
	game videoServer: videoServerClass fromUser.
	]! !

!RSViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2009 17:25'!
currentEnv
^currentEnv ! !

!RSViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2009 17:25'!
currentEnv: anEnvironment
currentEnv  := anEnvironment! !

!RSViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/13/2009 11:23'!
delete
	self disconnectAll.
	super delete! !

!RSViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/13/2009 11:23'!
disconnectAll
game disconnectAll.
! !

!RSViewerMorph methodsFor: 'robot server connection' stamp: 'Richo 10/21/2009 14:42'!
disconnectRobotServer
game disconnectRobotServer .
! !

!RSViewerMorph methodsFor: 'team connection' stamp: 'Richo 10/21/2009 14:42'!
disconnectTeam
game disconnectTeam.! !

!RSViewerMorph methodsFor: 'video server connection' stamp: 'Richo 10/21/2009 14:42'!
disconnectVideoServer
game disconnectVideoServer .
! !

!RSViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:08'!
game
^game! !

!RSViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/21/2009 13:48'!
gameState
	game isPaused ifTrue: [^#pause].
	game isStopped ifTrue: [^#stop].
	^#run! !

!RSViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:24'!
imagesHolder
^board imagesHolder! !

!RSViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/13/2009 10:51'!
initialize
	super initialize.
	self borderWidth: 2;
	color: ((Color
		r: 0.817
		g: 0.864
		b: 0.797)
		mixed: 0.75
		with: Color blue muchDarker);
		 borderColor: #raised;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 listDirection: #topToBottom;
		 cornerStyle: #rounded.
	game := RSGame new.
	self initializeSubmorphs.
! !

!RSViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/13/2009 12:22'!
initializeSubmorphs
	board := RSBoardMorph new.
	self addMorphBack: self makeExitPanel;
		 addMorphBack: self makeConnectionAndControlPanel;
		 addMorphBack: board.
	
	self addPluginList! !

!RSViewerMorph methodsFor: 'waiting process' stamp: 'Richo 10/13/2009 11:18'!
isWaitingProcessRunning
"Se fija si hay un proceso de espera de conexin activo"
	^ (Process allSubInstances
		reject: [:each | each isTerminated | (each name ~= self waitingProcessName)]) notEmpty! !

!RSViewerMorph methodsFor: 'building control panel' stamp: 'Richo 10/13/2009 10:40'!
makeConnectionAndControlPanel
	^ AlignmentMorph newRow color: Color transparent;
		 addMorphBack: self makeConnectionPanel;
		 addMorphBack: self makeControlPanel! !

!RSViewerMorph methodsFor: 'building control panel' stamp: 'Richo 10/13/2009 10:40'!
makeConnectionPanel
	^ AlignmentMorph newColumn color: Color transparent;
		 addMorphBack: self makeVideoServerControlPanel;
		 addMorphBack: self makeRobotServerControlPanel;
		 addMorphBack: self makeTeamControlPanel! !

!RSViewerMorph methodsFor: 'building control panel' stamp: 'Richo 10/13/2009 10:45'!
makeControlPanel
	^ AlignmentMorph newColumn color: Color transparent;
		 addMorphBack: self makeStartPauseStopPanel;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

!RSViewerMorph methodsFor: 'building control panel' stamp: 'Richo 10/13/2009 13:35'!
makeExitPanel
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: ('Robot Soccer Viewer' asMorph font: Preferences windowTitleFont);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (SimpleButtonMorph new label: '  X  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #delete;
			 target: self)! !

!RSViewerMorph methodsFor: 'building control panel' stamp: 'Richo 10/13/2009 11:03'!
makeRobotServerControlPanel
	| robotServerStringMorph refreshString |
	robotServerStringMorph := game robotServer asString asMorph.
	refreshString := [robotServerStringMorph contents: game robotServer asString].
	^ AlignmentMorph newRow color: Color transparent;
		 addMorphBack: (SimpleButtonMorph new label: '  RobotServer ...  ';
			
			color: (Color blue mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #value;
			 target: [self connectRobotServer. refreshString value]);
		 addMorphBack: (SimpleButtonMorph new label: '  Disconnect  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #value;
			 target: [self disconnectRobotServer. refreshString value]);
		 addMorphBack: ' --> ' asMorph;
		 addMorphBack: robotServerStringMorph;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

!RSViewerMorph methodsFor: 'building control panel' stamp: 'Richo 10/13/2009 10:41'!
makeStartPauseStopPanel
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
				 addMorphBack: AlignmentMorph newVariableTransparentSpacer ;
		 addMorphBack: (SimpleButtonMorph new label: '  Start  ';
			
			color: (Color green mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #start;
			 target: self);
		 addMorphBack: (SimpleButtonMorph new label: '  Pause  ';
			
			color: (Color blue mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #pause;
			 target: self);
		 addMorphBack: (SimpleButtonMorph new label: '  Stop  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #stop;
			 target: self)! !

!RSViewerMorph methodsFor: 'building control panel' stamp: 'Richo 10/13/2009 11:09'!
makeTeamControlPanel
	| teamStringMorph refreshString |
	teamStringMorph := game team asString asMorph.
	refreshString := [teamStringMorph contents: game team asString].
	
	^ AlignmentMorph newRow color: Color transparent;
		 addMorphBack: (SimpleButtonMorph new label: '  Team ...  ';
			
			color: (Color blue mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #value;
			 target: [self connectTeam. refreshString value]);
		 addMorphBack: (SimpleButtonMorph new label: '  Disconnect  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #value;
			 target: [self disconnectTeam. refreshString value]);
		 addMorphBack: ' --> ' asMorph;
		 addMorphBack: teamStringMorph;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

!RSViewerMorph methodsFor: 'building control panel' stamp: 'Richo 10/13/2009 11:01'!
makeVideoServerControlPanel
	| videoServerStringMorph refreshString |
	videoServerStringMorph := game videoServer asString asMorph.
	refreshString := [videoServerStringMorph contents: game videoServer asString].

	^ AlignmentMorph newRow color: Color transparent;
		 addMorphBack: (SimpleButtonMorph new label: '  VideoServer ...  ';
			
			color: (Color blue mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #value;
			 target: [self connectVideoServer. refreshString value]);
		 addMorphBack: (SimpleButtonMorph new label: '  Disconnect  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #value;
			 target: [self disconnectVideoServer. refreshString value]);
		 addMorphBack: ' --> ' asMorph;
		 addMorphBack: videoServerStringMorph;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

!RSViewerMorph methodsFor: 'start/pause/stop' stamp: 'Richo 10/21/2009 13:51'!
pause
game pause.! !

!RSViewerMorph methodsFor: 'start/pause/stop' stamp: 'Richo 10/21/2009 13:54'!
start	
	[game start] on: Error do: [:err| ^self inform: err description].
	board gameState: #wait! !

!RSViewerMorph methodsFor: 'waiting process' stamp: 'Richo 10/13/2009 11:31'!
startWaitingProcess
	"Se hace un proceso que muestra un mensaje de espera de conexin para
	no congelar Squeak mientras se espera una conexin nueva. Es
	necesario no mandar el mensaje #setRobotsAndBall hasta que se conecte
	porque crashea"
	[| strMorph | 
	strMorph := self waitingForConnectionStringMorph center: board center.
	board addMorph: strMorph.
	[(Delay forMilliseconds: 100) wait.
	game environment isYellowTeam isNil] whileTrue.
	strMorph delete.
	self startStepping]
		forkNamed: self waitingProcessName! !

!RSViewerMorph methodsFor: 'stepping' stamp: 'Richo 10/21/2009 14:40'!
step
	board
		 gameState: (self gameState).
	currentEnv := game environment.
	currentEnv isNil
		ifTrue: [^ self].
	currentEnv isYellowTeam isNil
		ifTrue: [^ self].
	plugins
		do: [:each | each stepIfActive]. 
	board
		 draw: currentEnv! !

!RSViewerMorph methodsFor: 'stepping' stamp: 'Richo 10/13/2009 11:53'!
stepTime
^100! !

!RSViewerMorph methodsFor: 'start/pause/stop' stamp: 'Richo 10/13/2009 11:22'!
stop
	game stop.
	self terminateWaitingProcess.
	self disconnectAll.
	self
		submorphsDo: [:m | m delete].
	self initializeSubmorphs! !

!RSViewerMorph methodsFor: 'waiting process' stamp: 'Richo 10/13/2009 11:18'!
terminateWaitingProcess
"Termina todos los procesos de espera de conexin que esten activos"
	(Process allSubInstances
		reject: [:each | each isTerminated | (each name ~= self waitingProcessName)])
		do: [:each | each terminate]! !

!RSViewerMorph methodsFor: 'waiting process' stamp: 'Richo 10/21/2009 13:31'!
waitingForConnectionStringMorph
	^ 'Waiting for connection ...' asMorph font: Preferences windowTitleFont;
		 color: Color red! !

!RSViewerMorph methodsFor: 'waiting process' stamp: 'Richo 10/13/2009 11:19'!
waitingProcessName
	^ self asString, '-waiting process'! !

TestCase subclass: #RSAngleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Tests'!

!RSAngleTest methodsFor: 'igual' stamp: 'Richo 6/21/2008 20:02'!
testIgual1
	| a1 a2 |
	a1 := RSAngle degrees: 45.
	a2 := RSAngle degrees: 45.
	self
		should: [a1 = a2].
	self
		shouldnt: [a1
				= (RSAngle degrees: 46)]! !

!RSAngleTest methodsFor: 'igual' stamp: 'Richo 6/21/2008 20:02'!
testIgual2
	| a1 a2 |
	a1 := RSAngle degrees: 45.
	a2 := RSAngle radians: 0.785398163397448.
	self
		should: [a1 = a2].
	self
		shouldnt: [a1
				= (RSAngle radians: 1)]! !

!RSAngleTest methodsFor: 'igual' stamp: 'Richo 6/21/2008 20:02'!
testIgual3
	| a1 a2 |
	a1 := RSAngle radians: 0.785398163397448.
	a2 := RSAngle degrees: 45.
	self
		should: [a1 = a2]! !

!RSAngleTest methodsFor: 'igual' stamp: 'Richo 6/21/2008 20:02'!
testIgual4
	| a1 a2 |
	a1 := RSAngle radians: 0.785398163397448.
	a2 := RSAngle radians: 0.78539817.
	self
		should: [a1 = a2]! !

!RSAngleTest methodsFor: 'igual' stamp: 'Richo 6/21/2008 20:02'!
testIgual5
	| a1 a2 |
	a1 := RSAngle degrees: 45.005.
	a2 := RSAngle degrees: 45.004.
	self
		should: [a1 = a2]! !

!RSAngleTest methodsFor: 'inicializacion' stamp: 'Richo 6/21/2008 20:04'!
testInicializacionGrados
	| a |
	a := RSAngle degrees: 45.
	self
		should: [a degrees = 45].
	self
		should: [a radians closeTo: 0.785398163397448].
! !

!RSAngleTest methodsFor: 'inicializacion' stamp: 'Richo 6/21/2008 20:05'!
testInicializacionGrados2
	| a |
	a := RSAngle degrees: -45.
	self
		should: [a degrees = -45].
	self
		should: [a radians closeTo: -0.785398163397448].
! !

!RSAngleTest methodsFor: 'inicializacion' stamp: 'Richo 6/21/2008 20:05'!
testInicializacionRadianes
	| a |
	a := RSAngle radians: 0.785398163397448.
	self
		should: [a degrees closeTo: 45].
	self
		should: [a radians closeTo: 0.785398163397448].
! !

!RSAngleTest methodsFor: 'inicializacion' stamp: 'Richo 6/21/2008 20:05'!
testInicializacionRadianes2
	| a |
	a := RSAngle radians: -0.785398163397448.
	self
		should: [a degrees closeTo: -45].
	self
		should: [a radians closeTo: -0.785398163397448].
! !

!RSAngleTest methodsFor: 'negated' stamp: 'Richo 6/21/2008 20:02'!
testNegated
	| a |
	a := RSAngle degrees: 45.
	self
		should: [a negated degrees closeTo: -45].
	self
		should: [a negated radians closeTo: -0.785398163397448]! !

!RSAngleTest methodsFor: 'negated' stamp: 'Richo 6/21/2008 20:02'!
testNegated2
	| a |
	a := RSAngle degrees: 180.
	self
		should: [a negated degrees closeTo: -180].
	self
		should: [a negated radians closeTo: -3.141592653589793]! !

!RSAngleTest methodsFor: 'opuesto' stamp: 'Richo 6/21/2008 20:03'!
testOpuesto
	| a |
	a := RSAngle degrees: 90.
	self
		should: [a opposite
				= (RSAngle degrees: -90)].
	self
		shouldnt: [a opposite
				= (RSAngle degrees: -91)]! !

!RSAngleTest methodsFor: 'opuesto' stamp: 'Richo 6/21/2008 20:03'!
testOpuesto2
	| a |
	a := RSAngle degrees: 45.
	self
		should: [a opposite
				= (RSAngle degrees: -135)].
	self
		shouldnt: [a opposite
				= (RSAngle degrees: -91)]! !

!RSAngleTest methodsFor: 'opuesto' stamp: 'Richo 6/21/2008 20:04'!
testOpuesto3
	| a |
	a := RSAngle degrees: 15.
	self
		should: [a opposite
				= (RSAngle degrees: -165)].
	self
		shouldnt: [a opposite
				= (RSAngle degrees: -91)]! !

!RSAngleTest methodsFor: 'opuesto' stamp: 'Richo 6/21/2008 20:04'!
testOpuesto4
	| a |
	a := RSAngle degrees: 0.
	self
		should: [a opposite
				= (RSAngle degrees: 180)].
	self
		shouldnt: [a opposite
				= (RSAngle degrees: -91)]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:02'!
testResta1
	| a1 a2 |
	a1 := RSAngle degrees: 179.
	a2 := RSAngle degrees: -2.
	self
		should: [(a1 - a2) degrees = -179]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:03'!
testResta2
	| a1 a2 |
	a1 := RSAngle degrees: 135.
	a2 := RSAngle degrees: -180.
	self
		should: [(a1 - a2) degrees = -45]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:03'!
testResta3
	| a1 a2 |
	a1 := RSAngle degrees: -135.
	a2 := RSAngle degrees: -180.
	self
		should: [(a1 - a2) degrees = 45]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:03'!
testResta4
	| a1 a2 |
	a1 := RSAngle degrees: -30.
	a2 := RSAngle degrees: 10.
	self
		should: [(a1 - a2) degrees = -40]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:03'!
testResta5
	| a1 a2 |
	a1 := RSAngle degrees: 10.
	a2 := RSAngle degrees: -30.
	self
		should: [(a1 - a2) degrees = 40]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:03'!
testResta6
	| a1 a2 |
	a1 := RSAngle degrees: -10.
	a2 := RSAngle degrees: 30.
	self
		should: [(a1 - a2) degrees = -40]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:03'!
testResta7
	| a1 a2 |
	a1 := RSAngle degrees: -45.
	a2 := RSAngle degrees: 0.
	self
		should: [(a1 - a2) degrees = -45]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma1
	| a1 a2 |
	a1 := RSAngle degrees: 45.
	a2 := RSAngle degrees: 90.
	self
		should: [(a1 + a2) degrees = 135]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma2
	| a1 a2 |
	a1 := RSAngle degrees: 135.
	a2 := RSAngle degrees: 90.
	self
		should: [(a1 + a2) degrees = -135]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma3
	| a1 a2 |
	a1 := RSAngle degrees: 45.
	a2 := RSAngle degrees: 180.
	self
		should: [(a1 + a2) degrees = -135]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma4
	| a1 a2 |
	a1 := RSAngle degrees: -45.
	a2 := RSAngle degrees: 180.
	self
		should: [(a1 + a2) degrees = 135]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma5
	| a1 a2 |
	a1 := RSAngle degrees: -45.
	a2 := RSAngle degrees: -180.
	self
		should: [(a1 + a2) degrees = 135]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma6
	| a1 a2 |
	a1 := RSAngle degrees: -179.
	a2 := RSAngle degrees: -2.
	self
		should: [(a1 + a2) degrees = 179]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma7
	| a1 a2 |
	a1 := RSAngle degrees: 0.
	a2 := RSAngle degrees: 45.
	self
		should: [(a1 + a2) degrees = 45]! !

TestCase subclass: #RSEnvironmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Tests'!

!RSEnvironmentTest methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 16:22'!
testShouldDecideTeam
	| env home opponent currentBall lastBall |
	env := RSEnvironment new.
	home := Array new: 5.
	opponent := Array new: 5.
	1
		to: 5
		do: [:i | 
			home
				at: i
				put: (RSRobot new environment: env).
			opponent at: i put: RSOpponentRobot new].
	currentBall := RSBall new.
	lastBall := RSBall new.
	env home: home;
		 opponent: opponent;
		 currentBall: currentBall;
		 lastBall: lastBall.
	! !

TestCase subclass: #RSRobotExampleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Tests'!

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: 10 @ 10.
	self
		should: [ang degrees closeTo: 45]! !

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo2
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: 10 @ 0.
	self
		should: [ang degrees closeTo: 0]! !

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo3
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: 0 @ 10.
	self
		should: [ang degrees closeTo: 90]! !

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo4
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: -10 @ -10.
	self
		should: [ang degrees closeTo: -135]! !

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo5
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: -10 @ 10.
	self
		should: [ang degrees closeTo: 135]! !

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo6
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: 0 @ -10.
	self
		should: [ang degrees closeTo: -90]! !

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo7
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: -10 @ 0.
	self
		should: [ang degrees closeTo: 180]! !

!RSRobotExampleTest methodsFor: 'cuadranteDe' stamp: 'Richo 6/22/2008 22:20'!
testCuadranteDe
	| robot cuadrante |
	robot := RSRobotExample new.
	robot position: 0 @ 0.
	cuadrante := robot quadrant: 10 @ 10.
	self
		should: [cuadrante = 1].
	cuadrante := robot quadrant: -10 @ 10.
	self
		should: [cuadrante = 2].
	cuadrante := robot quadrant: -10 @ -10.
	self
		should: [cuadrante = 3].
	cuadrante := robot quadrant: 10 @ -10.
	self
		should: [cuadrante = 4]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 45).
	robot position: 0 @ 0.
	obj := 10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado10
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 0).
	robot position: 0 @ 0.
	obj := 0 @ 10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado11
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 90).
	robot position: 0 @ 0.
	obj := 10 @ -10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado12
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 135).
	robot position: 0 @ 0.
	obj := 10 @ -1.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado13
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: -135).
	robot position: 0 @ 0.
	obj := 10 @ -1.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado14
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 0).
	robot position: 0 @ 0.
	obj := 0 @ 10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado15
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 0).
	robot position: 0 @ 0.
	obj := 0 @ -10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado2
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 45).
	robot position: 0 @ 0.
	obj := -10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado3
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 90).
	robot position: 0 @ 0.
	obj := -10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado4
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 90).
	robot position: 0 @ 0.
	obj := 10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado5
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: -90).
	robot position: 0 @ 0.
	obj := -10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado6
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 45).
	robot position: 0 @ 0.
	obj := 0 @ 10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado7
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: -90).
	robot position: 0 @ 0.
	obj := 10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado8
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: -45).
	robot position: 0 @ 0.
	obj := 0 @ -10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado9
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 135).
	robot position: 0 @ 0.
	obj := -10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoA
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 45).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: 10 @ 10].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoA10
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: -10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoA2
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: 10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoA3
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: 10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoA4
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 90).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: 0 @ -10].
	self
		should: [robot isLookingTo: 0 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeEspaldasA1
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: 10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeEspaldasA2
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: -10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeEspaldasA3
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: 10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeEspaldasA4
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: 10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeEspaldasA5
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: -10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeFrenteA
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 45).
	robot position: 0 @ 0.
	self
		should: [robot lookInFrontOf: 10 @ 10].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeFrenteA10
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot lookInFrontOf: -10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeFrenteA2
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot lookInFrontOf: 10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeFrenteA3
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot lookInFrontOf: 10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:22'!
testMirandoDeFrenteA4
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 90).
	robot position: 0 @ 0.
	self
		shouldnt: [robot lookInFrontOf: 0 @ -10].
	self
		should: [robot lookInFrontOf: 0 @ 10]! !

TestCase subclass: #RSViewerMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Tests'!

!RSViewerMorphTest methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2008 22:10'!
testAngleConversion
	| angSimu angSqueak |
	angSimu := 90.
	angSqueak := RSBoardMorph squeakAngle: angSimu.
	self
		should: [angSqueak = 0]! !

!RSViewerMorphTest methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2008 22:10'!
testAngleConversion2
	| angSimu angSqueak |
	angSimu := 0.
	angSqueak := RSBoardMorph squeakAngle: angSimu.
	self
		should: [angSqueak = 90]! !

!RSViewerMorphTest methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2008 22:10'!
testAngleConversion3
	| angSimu angSqueak |
	angSimu := -179.
	angSqueak := RSBoardMorph squeakAngle: angSimu.
	self
		should: [angSqueak = -91]! !

!RSViewerMorphTest methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2008 22:10'!
testAngleConversion4
	| angSimu angSqueak |
	angSimu := 179.
	angSqueak := RSBoardMorph squeakAngle: angSimu.
	self
		should: [angSqueak = -89]! !
